import java.util.Iterator;

public class MySet<T> extends MyArrayList<T> implements Iterable<T> {

    public MySet() {

    }


    @Override
    public void add(T data){
        // Sets cannot have duplicates
        boolean hasItem = false;

            for (Object o: getMyArrayList()) {
                if (o.equals(data)) {
                    hasItem = true;
                    break;
                }
            }

            if (!hasItem) {
            Object[] tempArray1 = new Object[getSize() + 1];
            copy(tempArray1, getMyArrayList());
            tempArray1[getSize()] = data;
            setMyArrayList(tempArray1);
            setSize(getSize() + 1);

        }
    }

    public class SetIterator implements Iterator<T> {
        int current = 0;

        public boolean hasNext() {
            if (current < getSize()) {
                return true;
            }
            return false;
        }

        @Override
        public T next() {
            if (!hasNext()) {
                throw new ArrayIndexOutOfBoundsException();
            }

            return (T) getMyArrayList()[current++];
        }

        @Override
        public void remove() {
        // removes current -1
            if (current < getSize() - 1) {
                MySet.this.remove(next());
            }

        }
    }

    @Override
    public Iterator<T> iterator() {
        return new SetIterator();
    }
}
