import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class MySetTest {

    MySet<Integer> mySet;

    @Before
    public void setUp() {
        mySet = new MySet<>();

    }

    @Test
    public void testAddUnique() {
        int expectedOutput = 1;
        mySet.add(1);
        Assert.assertEquals(expectedOutput, mySet.getMyArrayList()[mySet.getSize()-1]);
    }

    @Test
    public void testAddNotUnique() {

        int expectedSize = 2;
        mySet.add(1);
        mySet.add(2);
        mySet.add(1);

        Assert.assertEquals(expectedSize, mySet.getSize());
    }

    @Test
    public void testContainsTrue() {

        mySet.add(1);
        mySet.add(2);
        mySet.add(5);
        mySet.add(10);

        Assert.assertTrue(mySet.contains(2));
    }

    @Test
    public void testContainsFalse() {
        mySet.add(1);
        mySet.add(2);
        mySet.add(5);
        mySet.add(10);

        Assert.assertFalse(mySet.contains(3));
    }


}
